# Nano Banana Pro API

> Pinakamalakas na larawan modelo ng Google, na maaasahan sa lettering, kumplikadong layout at output na hanggang 4K.

Isang modelo ng larawan na nakabatay sa Gemini na gumagamit ng reasoning tungkol sa prompt bago gumuhit, kaya mas madalas na tama ang mga poster, infographic, menu at larawan ng produkto na may nababasang teksto kumpara sa mga modelong diffusion lang ang gamit. Pumili ng 1K, 2K o 4K na output at anumang karaniwang aspect ratio, at opsyonal na hayaan itong maghanap sa web upang ibatay ang larawan sa kasalukuyang impormasyon. Hanggang apat na larawan sa bawat kahilingan.

- Model id: `nano-banana-pro`
- Made by: Google
- Category: Text to Image
- Output: image
- Price: from $0.15 / image (cheapest run $0.15 (150 API credits))
- Run: `POST https://api.doitong.com/v1/run/nano-banana-pro`
- Quote: `POST https://api.doitong.com/v1/quote/nano-banana-pro`
- Docs page: https://doitong.com/fil/developers/models/nano-banana-pro

## Pricing

Price: **from $0.15 / image** (the lowest tier; the quote prices your exact input). Billed per generated image (`num_images`, default 1).

Price rules (the first rule that matches the input wins; a parameter you leave out counts as its default):

- When `resolution` = 4K and `enable_web_search` = true: $0.315 (315 API credits) / image
- When `resolution` = 4K: $0.30 (300 API credits) / image
- When `enable_web_search` = true: $0.165 (165 API credits) / image

The full example input below costs $0.15 = 150 API credits (1 image × 150 API credits).

Prices are the upstream price in USD, paid from the API balance in API credits (1000 API credits = 1 USD). `POST https://api.doitong.com/v1/quote/nano-banana-pro` with the same JSON body returns the exact price for that input; the quote is exactly what a run charges. Invalid input is never charged and failed or canceled requests are refunded automatically.

## Input parameters

Send either the canonical name or the native field name (not both). Canonical names are the same across models.

| Parameter | Canonical name | Type | Required | Default | Allowed values / range | Description |
|---|---|---|---|---|---|---|
| `prompt` |  | string | yes |  | 3 – 50000 characters | Mga text instruction na ginagamit para bumuo ng larawan. |
| `num_images` | `num_outputs` | integer | no | `1` | 1 – 4 | Bilang ng larawang hinihingi para sa pagbuo. |
| `seed` |  | integer \| null | no |  |  | Seed value na nag-i-initialize sa pagbuo ng random number. |
| `aspect_ratio` |  | enum (string) \| null | no | `1:1` | `auto`, `21:9`, `16:9`, `3:2`, `4:3`, `5:4`, `1:1`, `4:5`, `3:4`, `2:3`, `9:16` | Aspect ratio ng resultang larawan. |
| `output_format` |  | enum (string) | no | `png` | `jpeg`, `png`, `webp` | File format ng resultang larawan. |
| `safety_tolerance` |  | enum (string) | no | `4` | `1`, `2`, `3`, `4`, `5`, `6` | Itakda ang tolerance sa content moderation sa pagitan ng pinakamababang restrictive na level, 6, at pinakamahigpit na level, 1, na humaharang sa karamihan ng content. |
| `system_prompt` |  | string | no | `` | ≤ 50000 characters | Opsyonal na guidance para sa persona at output style sa buong kahilingan, na ipinapadala sa Gemini bilang system instruction o sa mga provider na compatible sa OpenAI bilang system message. Walang ipinapadala para sa instruction na ito kapag blanko ang value. |
| `resolution` |  | enum (string) | no | `1K` | `1K`, `2K`, `4K` | Resolution ng output na larawan. |
| `limit_generations` |  | boolean | no | `true` |  | Experimental na limitasyon sa pagbuo: kapag pinagana ang `True`, ino-override nito ang anumang direksyon sa bilang ng larawan sa prompt at nililimitahan ang bawat prompting round sa 1 pagbuo. |
| `enable_web_search` |  | boolean | no | `false` |  | Toggle ng web search para sa pagbuo ng larawan, na nagpapahintulot sa modelo na isama sa larawan ang napapanahong impormasyong nahanap online. |

## Example input

Required parameters only:

```json
{
  "prompt": "A minimalist poster for a jazz night called \"Blue Hour\", a saxophone silhouette against a deep blue sky, bold sans-serif title"
}
```

A fuller example:

```json
{
  "prompt": "A minimalist poster for a jazz night called \"Blue Hour\", a saxophone silhouette against a deep blue sky, bold sans-serif title",
  "aspect_ratio": "3:4",
  "resolution": "2K"
}
```

## Run it

Set `DOITONG_API_KEY` to a key from https://doitong.com/developers/dashboard#keys. `?wait=20` returns the finished request in the same call when it is ready within 20 seconds; otherwise poll `GET /requests/{id}` (it also accepts `?wait=`), or pass `webhook_url`.

### curl

```bash
# Run the model; wait up to 20 s for the finished result in the same call
curl -X POST "https://api.doitong.com/v1/run/nano-banana-pro?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY" \
  -H "Content-Type: application/json" \
  -d '{
    "prompt": "A minimalist poster for a jazz night called \"Blue Hour\", a saxophone silhouette against a deep blue sky, bold sans-serif title",
    "aspect_ratio": "3:4",
    "resolution": "2K"
  }'

# Still "queued" or "running"? Poll with the id from the response:
curl "https://api.doitong.com/v1/requests/REQUEST_ID?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY"
```

### JavaScript

```javascript
const API = "https://api.doitong.com/v1";
const headers = {
  "Authorization": "Bearer " + process.env.DOITONG_API_KEY,
  "Content-Type": "application/json",
};

// Run the model; wait up to 20 s for the finished result in the same call
let res = await fetch(API + "/run/nano-banana-pro?wait=20", {
  method: "POST",
  headers,
  body: JSON.stringify({
    "prompt": "A minimalist poster for a jazz night called \"Blue Hour\", a saxophone silhouette against a deep blue sky, bold sans-serif title",
    "aspect_ratio": "3:4",
    "resolution": "2K"
  }),
});
let request = await res.json();
if (!res.ok) throw new Error(request.error.code + ": " + request.error.message);

// Not finished yet: long-poll until it is
while (request.status === "queued" || request.status === "running") {
  res = await fetch(API + "/requests/" + request.id + "?wait=20", { headers });
  request = await res.json();
}
if (request.status !== "succeeded") throw new Error(JSON.stringify(request.error));
console.log(request.outputs.map((o) => o.url), request.cost.credits + " API credits ($" + request.cost.usd + ")");
```

### Python

```python
import os
import requests

API = "https://api.doitong.com/v1"
headers = {"Authorization": "Bearer " + os.environ["DOITONG_API_KEY"]}

payload = {
    "prompt": "A minimalist poster for a jazz night called \"Blue Hour\", a saxophone silhouette against a deep blue sky, bold sans-serif title",
    "aspect_ratio": "3:4",
    "resolution": "2K",
}

# Run the model; wait up to 20 s for the finished result in the same call
r = requests.post(API + "/run/nano-banana-pro", params={"wait": 20}, json=payload, headers=headers)
request = r.json()
if not r.ok:
    raise RuntimeError(request["error"]["code"] + ": " + request["error"]["message"])

# Not finished yet: long-poll until it is
while request["status"] in ("queued", "running"):
    request = requests.get(API + "/requests/" + request["id"], params={"wait": 20}, headers=headers).json()
if request["status"] != "succeeded":
    raise RuntimeError(request["error"])
print([o["url"] for o in request["outputs"]], request["cost"]["credits"], "API credits", "$" + request["cost"]["usd"])
```

### MCP

The MCP server at `https://api.doitong.com/v1/mcp` exposes the tools `search_models`, `get_model`, `quote`, `run`, `get_request`, `cancel_request`, `list_requests`, `create_upload` and `get_account`. A `run` call for this model:

```json
{
  "jsonrpc": "2.0",
  "id": 1,
  "method": "tools/call",
  "params": {
    "name": "run",
    "arguments": {
      "model_id": "nano-banana-pro",
      "input": {
        "prompt": "A minimalist poster for a jazz night called \"Blue Hour\", a saxophone silhouette against a deep blue sky, bold sans-serif title",
        "aspect_ratio": "3:4",
        "resolution": "2K"
      },
      "wait_seconds": 20
    }
  }
}
```

## Response

Every call returns a request object. `status` is one of `queued`, `running`, `succeeded`, `failed`, `canceled`. `outputs` lists the generated files with URLs on our storage (kept forever, or 7 days with `?storage=temporary`; `storage` says which); `output` is the model's own result object with the same URLs.

```json
{
  "id": "req_8k2m4q7x1z9c3v5b6n0p2r4t",
  "object": "request",
  "model": "nano-banana-pro",
  "status": "succeeded",
  "created_at": "2026-10-20T12:00:00Z",
  "started_at": "2026-10-20T12:00:02Z",
  "completed_at": "2026-10-20T12:00:09Z",
  "queue_position": null,
  "cost": {
    "credits": 150,
    "usd": "0.15",
    "charged": 150,
    "refunded": 0
  },
  "input": {
    "prompt": "A minimalist poster for a jazz night called \"Blue Hour\", a saxophone silhouette against a deep blue sky, bold sans-serif title",
    "aspect_ratio": "3:4",
    "resolution": "2K"
  },
  "output": {
    "images": [
      {
        "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
        "content_type": "image/jpeg",
        "file_name": "0-output.jpeg",
        "file_size": 1843200,
        "width": 1024,
        "height": 768
      }
    ],
    "description": "string"
  },
  "outputs": [
    {
      "type": "image",
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
      "content_type": "image/jpeg",
      "file_size": 1843200,
      "width": 1024,
      "height": 768,
      "stored": true
    }
  ],
  "error": null,
  "metrics": {
    "inference_seconds": 6.8
  },
  "urls": {
    "self": "https://api.doitong.com/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t",
    "cancel": "https://api.doitong.com/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t/cancel"
  }
}
```

### Output fields (`output`)

| Field | Type | Description |
|---|---|---|
| `images` | array of object {url, content_type, file_name, file_size, width, height} | Mga larawang ginawa ng modelo. |
| `description` | string | Paglalarawang kasama ng mga nabuong larawan. |

## Related models

- [Nano Banana Pro Edit](https://doitong.com/developers/models/nano-banana-pro/edit.md) (`nano-banana-pro/edit`): from $0.15 / image
- [Nano Banana 2](https://doitong.com/developers/models/nano-banana-2.md) (`nano-banana-2`): from $0.06 / image
- [FLUX.1 \[dev\]](https://doitong.com/developers/models/flux/dev.md) (`flux/dev`): $0.025 / megapixel
- [FLUX.1 \[schnell\]](https://doitong.com/developers/models/flux/schnell.md) (`flux/schnell`): $0.003 / megapixel
- [FLUX.2 \[dev\]](https://doitong.com/developers/models/flux-2.md) (`flux-2`): $0.012 / megapixel
- [FLUX.2 \[pro\]](https://doitong.com/developers/models/flux-2-pro.md) (`flux-2-pro`): $0.015 / megapixel of output image
- [GPT Image 2.5 Text to Image](https://doitong.com/developers/models/openai/gpt-image-2.5/flare/text-to-image.md) (`openai/gpt-image-2.5/flare/text-to-image`): from $0.008 / image
- [Ideogram V4.5](https://doitong.com/developers/models/ideogram/v4.5.md) (`ideogram/v4.5`): from $0.03 / image

## Links

- HTML page: https://doitong.com/developers/models/nano-banana-pro
- All models and guides for AI agents: https://doitong.com/developers/llms.txt
- OpenAPI 3.1 with this model's typed request body: https://doitong.com/developers/openapi.json?model=nano-banana-pro
- Errors: https://doitong.com/developers/docs/errors
- Model details as JSON: https://api.doitong.com/v1/models/nano-banana-pro
